<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="公司名称" prop="companyId" >
        <el-select v-model="queryParams.companyId" placeholder="请选择所属公司" filterable size="small">
          <el-option v-for="(option, index) in companyList" :key="index" :value="option.dictValue" :label="option.dictLabel"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="医生名称" prop="doctorName">
        <el-input
          v-model="queryParams.doctorName"
          placeholder="请输入医生名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="医生账号" prop="doctorAccount">
        <el-input
          v-model="queryParams.doctorAccount"
          placeholder="请输入医生账号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="病人名称" prop="patientName">
        <el-input
          v-model="queryParams.patientName"
          placeholder="请输入病人名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="订单编号" prop="orderCode">
        <el-input
          v-model="queryParams.orderCode"
          placeholder="请输入订单编号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择状态" clearable size="small">
         <el-option
           v-for="dict in statusOptions"
           :key="dict.dictValue"
           :label="dict.dictLabel"
           :value="dict.dictValue"
         />
        </el-select>
      </el-form-item>
       <el-form-item label="创建时间" prop="createTime">
                 <el-date-picker v-model="createTime" size="small" style="width: 220px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" @change="change"></el-date-picker>
       </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['his:drugReport:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="drugReportList" @selection-change="handleSelectionChange" border height="550">
      <!-- <el-table-column label="id" align="center" prop="reportId" /> -->
      <el-table-column label="订单编号" align="center" prop="orderCode" width="180px"/>
      <el-table-column label="病人名称" align="center" prop="patientName" />
      <el-table-column label="所属公司" align="center" prop="companyName" />
      <el-table-column label="医生名称" align="center" prop="doctorName" />
      <el-table-column label="医生账号" align="center" prop="doctorAccount" />
      <el-table-column label="状态" align="center" prop="status" >
        <template slot-scope="scope">
            <dict-tag :options="statusOptions" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <el-table-column label="评分" align="center" prop="pingStar" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180"/>
      <el-table-column label="评价时间" align="center" prop="pingTime" width="180"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
             size="mini"
             type="text"
             @click="handledetails(scope.row)"
             >详情
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <el-drawer
    	:with-header="false"
       size="75%"
      :title="show.title" :visible.sync="show.open">
       <drugReportDetails  ref="Details" />
     </el-drawer>
  </div>
</template>

<script>
import { listDrugReport, getDrugReport, delDrugReport, addDrugReport, updateDrugReport, exportDrugReport } from "@/api/his/drugReport";
import {allList}from "@/api/company/company";
import drugReportDetails from '../../components/his/drugReportDetails.vue';
export default {
  name: "DrugReport",
  components: { drugReportDetails },
  data() {
    return {
      companyList:[],
      // 遮罩层
      show:{
              title:"报告详情",
              open:false,
            },
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用药报告表格数据
      drugReportList: [],

      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      statusOptions:[],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: null,
        doctorId: null,
        followId: null,
        storeOrderId: null,
        inquiryOrderId: null,
        status: null,
        reportSummary: null,
        reportAdvice: null,
        pingStar: null,
        pingTime: null,
        orderCode:null,
        doctorName:null,
        patientName:null,
        sTime:null,
        eTime:null,
      },
      createTime:null,
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getAllCompany();
    this.getDicts("sys_drug_report_status").then(response => {
      this.statusOptions = response.data;
    });
    this.getList();

  },
  methods: {
    getAllCompany() {
      allList().then(response => {
        this.companyList = response.rows;
      });
    },
    /** 查询用药报告列表 */
    getList() {
      this.loading = true;
      listDrugReport(this.queryParams).then(response => {
        this.drugReportList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    change(){
      if(this.createTime!=null){
          this.queryParams.sTime=this.createTime[0];
          this.queryParams.eTime=this.createTime[1];
      }else{
          this.queryParams.sTime=null;
          this.queryParams.eTime=null;
      }
    },
    // 表单重置
    reset() {
      this.form = {
        reportId: null,
        userId: null,
        doctorId: null,
        followId: null,
        storeOrderId: null,
        inquiryOrderId: null,
        status: 0,
        reportSummary: null,
        reportAdvice: null,
        pingStar: null,
        pingTime: null,
        createTime: null
      };

      this.resetForm("form");
    },
    handledetails(row){
      this.show.open=true;
      setTimeout(() => {
           this.$refs.Details.getDetails(row.reportId);
      }, 1);
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.createTime=null;
      this.queryParams.sTime=null;
      this.queryParams.eTime=null;
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.reportId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加用药报告";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const reportId = row.reportId || this.ids
      getDrugReport(reportId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改用药报告";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.reportId != null) {
            updateDrugReport(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDrugReport(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const reportIds = row.reportId || this.ids;
      this.$confirm('是否确认删除用药报告编号为"' + reportIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delDrugReport(reportIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有用药报告数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportDrugReport(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
